#include <plib.h>
#include "delay.h"


volatile int delay_isr_flag = 0;

void __ISR(_TIMER_1_VECTOR, ipl1) Timer1Handler(void)
{
	mT1ClearIntFlag();
	delay_isr_flag = 1;
}

void init_delay(){
	OpenTimer1(T1_ON | T1_SOURCE_INT | T1_PS_1_8, 0xFFFF);
	mT1IntEnable(0);
}

void delay_us(int us){
	delay_isr_flag = 0;
	WritePeriod1(us*5);
    WriteTimer1(0);
	mT1ClearIntFlag();
	ConfigIntTimer1(T1_INT_ON | T1_INT_PRIOR_1);
	while(!delay_isr_flag);
	mT1IntEnable(0);
}