#include "game_manager.h"

game_manager_t gm;
scene_t* scenes[10];
extern scene_t scene_rope;
extern scene_t scene_menu;
extern scene_t scene_countdown;
extern scene_t scene_pause;
extern scene_t scene_gameover;
extern scene_t scene_credits;
extern scene_t scene_demo_audio;
extern scene_t scene_demo_tooltip;

void game_manager_load_scene(int ind){
    gm.current_scene = scenes[ind];
    gm.current_scene->init_func(gm.current_scene, 0);
}

void game_manager_master_update(int dt){
    gm.current_scene->update_func(gm.current_scene, dt);
}

void game_manager_master_deinit(void){
    return;
}

void game_manager_load_scene_graphics(int ind){
    return;
}

scene_t* game_manager_get_scene(int ind){
    return scenes[ind];
}

void init_game_manager(void){
#ifdef enable_ntsc
	// init video
	init_ntsc_video();
#endif
#ifdef enable_controller
	// init controller
	init_controller();
#endif
	// init custom delay
	init_delay();
    
    // init audio
    init_audio();
    
    gm.update_func = game_manager_master_update;
    
    // define all the scenes here
    scenes[0] = &scene_menu;
    scenes[1] = &scene_rope;
    scenes[2] = &scene_countdown;
    scenes[3] = &scene_pause;
    scenes[4] = &scene_gameover;
    scenes[5] = &scene_credits;
    scenes[6] = &scene_demo_audio;
    scenes[7] = &scene_demo_tooltip;
    
    // start to init all the scenes
    gm.current_scene = scenes[0];
    gm.current_scene->init_func(gm.current_scene, 0);
}
