#ifndef _GAME_MANAGERH_
#define _GAME_MANAGERH_

#include "ntsc_video.h"
#include "controller.h"

#include "delay.h"
#include "sprite.h"
#include "scene.h"
#include "audio.h"

#include <math.h>

#include <stdlib.h>

#define enable_controller
#define enable_ntsc

typedef struct gm_struct game_manager_t;

extern game_manager_t gm; // global manager object, this should always stay

typedef void (*gm_func_t)(int);

struct gm_struct{
	gm_func_t update_func;
	scene_t* current_scene;
};

void init_game_manager(void);

void game_manager_load_scene(int ind);

void game_manager_master_update(int dt);

void game_manager_master_deinit(void);

void game_manager_load_scene_graphics(int ind);

scene_t* game_manager_get_scene(int ind);

// all the scenes defined below
extern scene_t scene_rope;

#endif