#ifndef _SPRITEH_
#define _SPRITEH_

#include <plib.h>
#include <stdlib.h>

typedef struct sprite_struct sprite_t;

typedef void (*sprite_func_t)(sprite_t*, int);

typedef struct v2d{
	int x;
	int y;
} vector2d;

struct sprite_struct{
	int width; // width
	int height; // height
	vector2d pos; // position
	int* data; // data array
	sprite_func_t update_func; // update function
	sprite_func_t init_func; // init function
	int frames; // number of frames
	int current_frame; // current number of frame display
} ;

// returns the position of the sprite, in vector2d
vector2d sprite_getpos(sprite_t* s);
// move the sprite
void sprite_move(sprite_t* s, vector2d* v);

// connects sprite to a update function
void sprite_set_update_function(sprite_t* s, sprite_func_t f);
// clears update func
void sprite_clear_update_function(sprite_t* s);

// connects sprite to a init function
void sprite_set_init_function(sprite_t* s, sprite_func_t f);
// clears init func
void sprite_clear_init_function(sprite_t* s);

#endif